import os
import json
from datetime import datetime
from influxdb_client import InfluxDBClient, Point
from influxdb_client.client.write_api import SYNCHRONOUS

# InfluxDB connection details
url = "http://localhost:8086"
token = "WUxftnono0_k_t620srsO7xNG15xcej5meoShrr1ONHGvWSEqwg3gJVhthKwux7wUyw1_1hm9TAQFWKeEBHK2g=="
org = "Student"
bucket = "ADG"

# Path to the folder containing the JSON file
folder_path = r"C:\Allianz\4\0211\1201\0301"
file_name = "beacon_logs.json"
file_path = os.path.join(folder_path, file_name)

# Connect to InfluxDB
client = InfluxDBClient(url=url, token=token, org=org)
write_api = client.write_api(write_options=SYNCHRONOUS)  # Fix here

# Read and insert the JSON file line by line
with open(file_path, "r") as file:
    for line in file:
        log_entry = json.loads(line.strip())

        # Extract values
        logdate = datetime.strptime(log_entry["logdate"], "%Y-%m-%dT%H:%M:%S.%fZ")
        url_hostname = log_entry["url_hostname"]
        user = log_entry["user"]

        # Create an InfluxDB data point
        point = Point("hostnames") \
            .tag("url_hostname", url_hostname) \
            .tag("source_file", file_name) \
            .field("user", user) \
            .time(logdate)

        # Write the point to InfluxDB
        write_api.write(bucket=bucket, org=org, record=point)

print("Data successfully inserted into InfluxDB.")

# Close the client
client.close()
